/*	Copyright  (c)	Günter Woigk 1994 - 2014
  					mailto:kio@little-bat.de

	This file is free software

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef AssZ80_h
#define AssZ80_h

#include "Ass.h"


class AssZ80 : public Ass
{
	bool		head;			// sna/z80:	true while #head

// object code storing
	void 		store_XYCB_op	( int pfx, int n, int dis );
	void		store_XY_byte_op( int pfx, int n, int dis );

// AssDirect()
virtual bool	assDirect		( cstr dir );		// z80 specific #directives

	void		handleHeadSna	( );
	void		handleHeadZ80	( );

	void		handleCodeSna	( );
	void		handleCodeZ80	( );
	void		handleCodeTap	( );
	void		handleCodeZX80	( );
	void		handleCodeZX81	( );

	void		writeTapeBlock	( );
	void		handlePageZ80	( );

	void		handleEndTap	( );
	void		handleEndZ80	( );
	void		handleEndSna	( );
	void		handleEndZX80	( );
	void		handleEndZX81	( );


// compiling
	int			getCondition 		( cstr w );
	int			getRegister 		( cstr w );
virtual bool	assInstr		( cstr opc );		// z80 specific opcodes

public:
//virtual void	reset			( );			// no own data members -> no need to reimplement reset()
//virtual void	Pass2			( );			// no own data members -> no need to reimplement Pass2()
};


#endif
